import urllib
from xml.dom import minidom

@plugin
class Wikipedia(object):
    def __init__(self, server):
        self.server = server
        self.commands = ["wiki"]
        self.server.handle("command", self.handle_command, self.commands)
    
    def handle_command(self, channel, user, cmd, args):
        if cmd == "wiki":
            if len(args) < 1: 
                self.server.doMessage(channel, user+": Not enough arguments.")
                return
            
            url = "http://en.wikipedia.org/w/api.php?action=opensearch&limit=3&namespace=0&format=xml&search="
            query = " ".join(args)
            search = url + urllib.quote_plus(query, "/")
            
            try:
                data = urllib.urlopen(search).readlines()
            except IOError, ioe:
                self.server.doMessage(channel, user+": I/O Error retrieving the results: "+ioe)
                return
            
            try:
                xmldoc = minidom.parseString(data[0]) 
            except xml.parsers.expat.ExpatError:
                self.server.doMessage(channel, user+": Error parsing the xml search results.")
                return
            
            self.server.doMessage(channel, user+": "+"Hi.")    
            searchResults = xmldoc.childNodes[0].childNodes[1].childNodes
            for result in searchResults:
                resultStr = ""
                print channel
                print user
                for item in result.childNodes:
                    for textNode in item.childNodes:
                        resultStr += textNode.data + " - "
                        print resultStr
                self.server.doMessage(channel, user+": "+str(resultStr))
